VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4650
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4500
   LinkTopic       =   "Form1"
   ScaleHeight     =   4650
   ScaleWidth      =   4500
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command3 
      Caption         =   "Median Cut"
      Height          =   495
      Left            =   3120
      TabIndex        =   4
      Top             =   2760
      Width           =   1335
   End
   Begin VB.CommandButton Command2 
      Caption         =   ""
      Height          =   495
      Left            =   3120
      TabIndex        =   3
      Top             =   1320
      Width           =   1335
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Octree"
      Height          =   495
      Left            =   3120
      TabIndex        =   2
      Top             =   2040
      Width           =   1335
   End
   Begin VB.PictureBox Picture2 
      AutoRedraw      =   -1  'True
      Height          =   2175
      Left            =   120
      ScaleHeight     =   141
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   189
      TabIndex        =   1
      Top             =   2400
      Width           =   2895
   End
   Begin VB.PictureBox Picture1 
      AutoRedraw      =   -1  'True
      Height          =   2175
      Left            =   120
      Picture         =   "Form4.frx":0000
      ScaleHeight     =   141
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   189
      TabIndex        =   0
      Top             =   120
      Width           =   2895
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Const NColors = 64 '2..256, powers of two

Private Sub Command1_Click()
'The original C++ code is (c) 2004, Sjaak Priester, Amsterdam.
'VB translation is (c) 2004, A. Skrobov
    Picture2.Cls
Dim NewPalette(0 To 255) As OLE_COLOR
Dim NumLeaves As Long, Head As OctreeNode, Root As OctreeNode
Dim x As Long, y As Long, c As OLE_COLOR
Dim r As Byte, g As Byte, b As Byte
    NumLeaves = 0       'counter of leaf nodes in octree
    Set Head = New OctreeNode
    Head.Create 1, Nothing, NumLeaves  ' head of list with reducible non-leaf nodes (dummy)
    Head.Level = 0
    Set Root = New OctreeNode
    Root.Create 7, Nothing, NumLeaves  ' root of octree

    ' Put tree root in reducible list. Root will always be the last node in the list,
    ' and also functions as list sentinel.
    Set Head.nNext = Root
    Set Root.nPrev = Head

    ' First loop: gather color information, put it in tree leaves
    For y = 0 To Picture1.ScaleHeight - 1    ' For each row...
        For x = 0 To Picture1.ScaleWidth - 1 ' ...for each pixel...
            c = Picture1.Point(x, y)
            r = c And 255&: c = c \ 256
            g = c And 255&: c = c \ 256
            b = c And 255&
            Root.SetColor r, g, b, Head, NumLeaves
                                ' ...add color to tree, make new leaf if necessary.

            While NumLeaves > NColors ' If in the process too many leaves are created...
                ' ... then, one by one, pick a non-leaf node...
                Dim Reducible As OctreeNode
                Set Reducible = Head.nNext

                Reducible.Remove   ' ...remove it from the list of reducibles...
                Reducible.GetQuantized NumLeaves  ' ...and reduce it to a leaf.
            Wend
        Next
    Next
    
    Root.FillPalette NewPalette, 0
    For y = 0 To Picture1.ScaleHeight - 1    ' For each row...
        For x = 0 To Picture1.ScaleWidth - 1 ' ...for each pixel...
            c = Picture1.Point(x, y)
            r = c And 255&: c = c \ 256
            g = c And 255&: c = c \ 256
            b = c And 255&
            Picture2.PSet (x, y), NewPalette(Root.GetPaletteIndex(r, g, b))
        Next
    Next
End Sub

Private Sub Command2_Click()
    Picture2.Cls
    Picture2.PaintPicture Picture1.Picture, 0, 0
End Sub

Private Sub Command3_Click()
    Picture2.Cls
Dim NewPalette(0 To 255) As OLE_COLOR
Dim x As Long, y As Long, c As OLE_COLOR
Dim crgb As RGB, r As Byte, g As Byte, b As Byte
Dim NumLeaves As Long, Root As MedCutNode
    NumLeaves = 1
    Set Root = New MedCutNode
    ReDim Pixels(0 To Picture1.ScaleWidth * Picture1.ScaleHeight - 1)
    For y = 0 To Picture1.ScaleHeight - 1    ' For each row...
        For x = 0 To Picture1.ScaleWidth - 1 ' ...for each pixel...
            c = Picture1.Point(x, y)
            crgb.Red = c And 255&: c = c \ 256
            crgb.Green = c And 255&: c = c \ 256
            crgb.Blue = c And 255&
            Pixels(y * Picture1.ScaleWidth + x) = crgb
        Next
    Next
    Root.SetBounds LBound(Pixels), UBound(Pixels)
    While NumLeaves < NColors
        Root.Split
        NumLeaves = NumLeaves * 2
'instead of doing it 8 times :-)
    Wend
    Root.FillPalette NewPalette, 0
    For y = 0 To Picture1.ScaleHeight - 1    ' For each row...
        For x = 0 To Picture1.ScaleWidth - 1 ' ...for each pixel...
            c = Picture1.Point(x, y)
            r = c And 255&: c = c \ 256
            g = c And 255&: c = c \ 256
            b = c And 255&
            Picture2.PSet (x, y), NewPalette(Root.GetPaletteIndex(r, g, b))
        Next
    Next
End Sub
